package edu.mermet.tp8.aide;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Random;
import java.util.ResourceBundle;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

import edu.mermet.tp8.Application;
import edu.mermet.tp8.Preferences;

public class FenetreSuggestion extends JDialog {
	
	Application application;
	JTextArea tipArea;
	JPanel boutons;
	JButton btnFermer;
	JButton btnNePlusAfficher;
	boolean visible;
	String suggestionKey;
	
	public FenetreSuggestion(Application a){
		super(a, true);
		application = a;
		visible = true;
		init();
		setTitle("Configuration des menus");
		pack();
		setLocationRelativeTo(null);
		setVisible(visible);
	}
	
	private void init() {
		tipArea = new JTextArea(pickATip());
		tipArea.setEditable(false);
		add(tipArea, BorderLayout.CENTER);
		boutons = new JPanel();
		btnFermer = new JButton(new ActionFermer());
		boutons.add(btnFermer);
		btnNePlusAfficher = new JButton(new ActionNePlusAfficher());
		boutons.add(btnNePlusAfficher);
		add(boutons, BorderLayout.SOUTH);
	}

	private String pickATip() {
		ResourceBundle bSug = ResourceBundle.getBundle("Suggestions.suggestions");
		// Récupération des suggestion et Suppression des indésirables
		ResourceBundle bComp = ResourceBundle.getBundle("suggestions.complexites");
		List<String> suggPossibles = bSug.keySet().stream()
			.filter(key -> Float.parseFloat(bComp.getString(key)) <= Preferences.getInstance().getNiveau())
			.collect(Collectors.toList());
		suggPossibles.removeAll(Preferences.getInstance().getSuggestionIndesirables());
		//------------------------------------------------------------
		if(suggPossibles.isEmpty()) {
			visible = false;
			return "Plus d'astuces pour vous :(";
		}
		suggestionKey = suggPossibles.get(new Random().nextInt(suggPossibles.size()));
		return bSug.getString(suggestionKey);
	}
	
	public class ActionFermer extends AbstractAction {
        public ActionFermer() {
            super("Fermer");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
            dispose();
        }
    }
	
	public class ActionNePlusAfficher extends AbstractAction {
        public ActionNePlusAfficher() {
            super("Ne plus afficher");
        }

        @Override
        public void actionPerformed(ActionEvent ae) {
        	Preferences.getInstance().addSuggestionIndesirable(suggestionKey);
        	Preferences.getInstance().persist();
            dispose();
        }
    }
}
